# in part taken from /lib/keyboard from Plan 9

set snippets {
  {"apqq" "⍞"}
  {"apsq" "⌷"}
  {"apqj" "⌻"}
  {"apqd" "⍌"}
  {"[]" "⌷"}
  {"!!" "¡"}
  {"c$" "¢"}
  {"l$" "£"}
  {"g$" "¤"}
  {"y$" "¥"}
  {"||" "¦"}
  {"SS" "§"}
  {"\"" "¨"}
  {"Oc" "©"}
  {"sa" "ª"}
  {"<<" "«"}
  {"no" "¬"}
  {"--" "­"}
  {"Or" "®"}
  {"__" "¯"}
  {"de" "°"}
  {"+-" "±"}
  {"s2" "²"}
  {"s3" "³"}
  {"''" "´"}
  {"mi" "µ"}
  {"pg" "¶"}
  {".." "·"}
  {",," "¸"}
  {"s1" "¹"}
  {"so" "º"}
  {">>" "»"}
  {"14" "¼"}
  {"12" "½"}
  {"34" "¾"}
  {"??" "¿"}
  {"`A" "À"}
  {"'A" "Á"}
  {"^A" "Â"}
  {"~A" "Ã"}
  {"\"A" "Ä"}
  {"oA" "Å"}
  {"AE" "Æ"}
  {",C" "Ç"}
  {"`E" "È"}
  {"'E" "É"}
  {"^E" "Ê"}
  {"\"E" "Ë"}
  {"`I" "Ì"}
  {"'I" "Í"}
  {"^I" "Î"}
  {"\"I" "Ï"}
  {"-D" "Ð"}
  {"~N" "Ñ"}
  {"`O" "Ò"}
  {"'O" "Ó"}
  {"^O" "Ô"}
  {"~O" "Õ"}
  {"\"O" "Ö"}
  {"mu" "×"}
  {"/O" "Ø"}
  {"`U" "Ù"}
  {"'U" "Ú"}
  {"^U" "Û"}
  {"\"U" "Ü"}
  {"'Y" "Ý"}
  {"|P" "Þ"}
  {"ss" "ß"}
  {"`a" "à"}
  {"'a" "á"}
  {"^a" "â"}
  {"~a" "ã"}
  {"\"a" "ä"}
  {"oa" "å"}
  {"ae" "æ"}
  {",c" "ç"}
  {"`e" "è"}
  {"'e" "é"}
  {"^e" "ê"}
  {"\"e" "ë"}
  {"`i" "ì"}
  {"'i" "í"}
  {"^i" "î"}
  {"\"i" "ï"}
  {"-d" "ð"}
  {"~n" "ñ"}
  {"`o" "ò"}
  {"'o" "ó"}
  {"^o" "ô"}
  {"~o" "õ"}
  {"\"o" "ö"}
  {"-:" "÷"}
  {"/o" "ø"}
  {"`u" "ù"}
  {"'u" "ú"}
  {"^u" "û"}
  {"\"u" "ü"}
  {"'y" "ý"}
  {"|p" "þ"}
  {"\"y" "ÿ"}
  {"_A" "Ā"}
  {"_a" "ā"}
  {"uA" "Ă"}
  {",A" "Ą"}
  {",a" "ą"}
  {"'C" "Ć"}
  {"'c" "ć"}
  {"^C" "Ĉ"}
  {"^c" "ĉ"}
  {".C" "Ċ"}
  {".c" "ċ"}
  {"vC" "Č"}
  {"vc" "č"}
  {"vD" "Ď"}
  {"vd" "ď"}
  {"_E" "Ē"}
  {"_e" "ē"}
  {"uE" "Ĕ"}
  {"ue" "ĕ"}
  {".E" "Ė"}
  {".e" "ė"}
  {",E" "Ę"}
  {",e" "ę"}
  {"vE" "Ě"}
  {"ve" "ě"}
  {"^G" "Ĝ"}
  {"^g" "ĝ"}
  {"uG" "Ğ"}
  {"ug" "ğ"}
  {".G" "Ġ"}
  {".g" "ġ"}
  {",G" "Ģ"}
  {"'g" "ģ"}
  {"^H" "Ĥ"}
  {"^h" "ĥ"}
  {"-H" "Ħ"}
  {"~I" "Ĩ"}
  {"~i" "ĩ"}
  {"_I" "Ī"}
  {"_i" "ī"}
  {"uI" "Ĭ"}
  {"ui" "ĭ"}
  {",I" "Į"}
  {",i" "į"}
  {".I" "İ"}
  {"i" "ı"}
  {"IJ" "Ĳ"}
  {"ij" "ĳ"}
  {"^J" "Ĵ"}
  {"^j" "ĵ"}
  {",K" "Ķ"}
  {",k" "ķ"}
  {"'L" "Ĺ"}
  {"'l" "ĺ"}
  {",L" "Ļ"}
  {",l" "ļ"}
  {"vL" "Ľ"}
  {"vl" "ľ"}
  {".L" "Ŀ"}
  {".l" "ŀ"}
  {"-L" "Ł"}
  {"-l" "ł"}
  {"'N" "Ń"}
  {"'n" "ń"}
  {",N" "Ņ"}
  {",n" "ņ"}
  {"vN" "Ň"}
  {"vn" "ň"}
  {"_O" "Ō"}
  {"_o" "ō"}
  {"uO" "Ŏ"}
  {"uo" "ŏ"}
  {"OE" "Œ"}
  {"oe" "œ"}
  {"'R" "Ŕ"}
  {"'r" "ŕ"}
  {",R" "Ŗ"}
  {",r" "ŗ"}
  {"vR" "Ř"}
  {"vr" "ř"}
  {"'S" "Ś"}
  {"'s" "ś"}
  {"^S" "Ŝ"}
  {"^s" "ŝ"}
  {",S" "Ş"}
  {",s" "ş"}
  {"vS" "Š"}
  {"vs" "š"}
  {",T" "Ţ"}
  {",t" "ţ"}
  {"vT" "Ť"}
  {"vt" "ť"}
  {"-T" "Ŧ"}
  {"-t" "ŧ"}
  {"~U" "Ũ"}
  {"~u" "ũ"}
  {"_U" "Ū"}
  {"_u" "ū"}
  {"uU" "Ŭ"}
  {"uu" "ŭ"}
  {"oU" "Ů"}
  {"ou" "ů"}
  {",U" "Ų"}
  {",u" "ų"}
  {"^W" "Ŵ"}
  {"^w" "ŵ"}
  {"^Y" "Ŷ"}
  {"^y" "ŷ"}
  {"\"Y" "Ÿ"}
  {"'Z" "Ź"}
  {"'z" "ź"}
  {".Z" "Ż"}
  {".z" "ż"}
  {"vZ" "Ž"}
  {"vz" "ž"}
  {"-b" "ƀ"}
  {"$f" "ƒ"}
  {"hv" "ƕ"}
  {"-I" "Ɨ"}
  {"-*l" "ƛ"}
  {"OI" "Ƣ"}
  {"oi" "ƣ"}
  {"YR" "Ʀ"}
  {"$V" "Ʋ"}
  {"-Z" "Ƶ"}
  {"-z" "ƶ"}
  {"-2" "ƻ"}
  {"DvZ" "Ǆ"}
  {"Dvz" "ǅ"}
  {"dvz" "ǆ"}
  {"LJ" "Ǉ"}
  {"Lj" "ǈ"}
  {"lj" "ǉ"}
  {"NJ" "Ǌ"}
  {"Nj" "ǋ"}
  {"nj" "ǌ"}
  {"vA" "Ǎ"}
  {"va" "ǎ"}
  {"vI" "Ǐ"}
  {"vi" "ǐ"}
  {"vO" "Ǒ"}
  {"vo" "ǒ"}
  {"vU" "Ǔ"}
  {"vu" "ǔ"}
  {"_\"U" "Ǖ"}
  {"_\"u" "ǖ"}
  {"'\"U" "Ǘ"}
  {"'\"u" "ǘ"}
  {"v\"U" "Ǚ"}
  {"v\"u" "ǚ"}
  {"`\"U" "Ǜ"}
  {"`\"u" "ǜ"}
  {"_\"A" "Ǟ"}
  {"_\"a" "ǟ"}
  {"_.A" "Ǡ"}
  {"_.a" "ǡ"}
  {"-G" "Ǥ"}
  {"-g" "ǥ"}
  {"vG" "Ǧ"}
  {"vg" "ǧ"}
  {"vK" "Ǩ"}
  {"vk" "ǩ"}
  {",O" "Ǫ"}
  {",o" "ǫ"}
  {"_,O" "Ǭ"}
  {"_,o" "ǭ"}
  {"vj" "ǰ"}
  {"$a" "ɑ"}
  {"-i" "ɨ"}
  {"-u" "ʉ"}
  {"$v" "ʋ"}
  {"dz" "ʣ"}
  {"*A" "Α"}
  {"*B" "Β"}
  {"*G" "Γ"}
  {"*D" "Δ"}
  {"*E" "Ε"}
  {"*Z" "Ζ"}
  {"*Y" "Η"}
  {"*H" "Θ"}
  {"*I" "Ι"}
  {"*K" "Κ"}
  {"*L" "Λ"}
  {"*M" "Μ"}
  {"*N" "Ν"}
  {"*C" "Ξ"}
  {"*O" "Ο"}
  {"*P" "Π"}
  {"*R" "Ρ"}
  {"*S" "Σ"}
  {"*T" "Τ"}
  {"*U" "Υ"}
  {"*F" "Φ"}
  {"*X" "Χ"}
  {"*Q" "Ψ"}
  {"*W" "Ω"}
  {"\"*I" "Ϊ"}
  {"\"*U" "Ϋ"}
  {"*a" "α"}
  {"*b" "β"}
  {"*g" "γ"}
  {"*d" "δ"}
  {"*e" "ε"}
  {"*z" "ζ"}
  {"*y" "η"}
  {"*h" "θ"}
  {"*i" "ι"}
  {"*k" "κ"}
  {"*l" "λ"}
  {"*m" "μ"}
  {"*n" "ν"}
  {"*c" "ξ"}
  {"*o" "ο"}
  {"*p" "π"}
  {"*r" "ρ"}
  {"ts" "ς"}
  {"*s" "σ"}
  {"*t" "τ"}
  {"*u" "υ"}
  {"*f" "φ"}
  {"*x" "χ"}
  {"*q" "ψ"}
  {"*w" "ω"}
  {"\"*i" "ϊ"}
  {"\"*u" "ϋ"}
  {"$*h" "ϑ"}
  {"$*f" "ϕ"}
  {"$*k" "ϰ"}
  {"l'" "‘"}
  {"r'" "’"}
  {"l\"" "“"}
  {"r\"" "”"}
  {"dg" "†"}
  {"dd" "‡"}
  {"bu" "•"}
  {"1." "․"}
  {"2." "‥"}
  {"3." "…"}
  {"!?" "‽"}
  {"s0" "⁰"}
  {"s4" "⁴"}
  {"s5" "⁵"}
  {"s6" "⁶"}
  {"s7" "⁷"}
  {"s8" "⁸"}
  {"s9" "⁹"}
  {"s+" "⁺"}
  {"s-" "⁻"}
  {"s=" "⁼"}
  {"s(" "⁽"}
  {"s)" "⁾"}
  {"sn" "ⁿ"}
  {"en" "–"}
  {"em" "—"}
  {"b0" "₀"}
  {"b1" "₁"}
  {"b2" "₂"}
  {"b3" "₃"}
  {"b4" "₄"}
  {"b5" "₅"}
  {"b6" "₆"}
  {"b7" "₇"}
  {"b8" "₈"}
  {"b9" "₉"}
  {"b+" "₊"}
  {"b-" "₋"}
  {"b=" "₌"}
  {"b(" "₍"}
  {"b)" "₎"}
  {"e$" "€"}
  {"CC" "ℂ"}
  {"$g" "ℊ"}
  {"$H" "ℋ"}
  {"HH" "ℍ"}
  {"-h" "ℏ"}
  {"$I" "ℐ"}
  {"$L" "ℒ"}
  {"$l" "ℓ"}
  {"NN" "ℕ"}
  {"Op" "℗"}
  {"$p" "℘"}
  {"PP" "ℙ"}
  {"QQ" "ℚ"}
  {"$R" "ℛ"}
  {"RR" "ℝ"}
  {"tm" "™"}
  {"ZZ" "ℤ"}
  {"$B" "ℬ"}
  {"$e" "ℯ"}
  {"$E" "ℰ"}
  {"$F" "ℱ"}
  {"$M" "ℳ"}
  {"$o" "ℴ"}
  {"13" "⅓"}
  {"23" "⅔"}
  {"15" "⅕"}
  {"25" "⅖"}
  {"35" "⅗"}
  {"45" "⅘"}
  {"16" "⅙"}
  {"56" "⅚"}
  {"18" "⅛"}
  {"38" "⅜"}
  {"58" "⅝"}
  {"78" "⅞"}
  {"<-" "←"}
  {"ua" "↑"}
  {"->" "→"}
  {"da" "↓"}
  {"ab" "↔"}
  {"V=" "⇐"}
  {"=V" "⇒"}
  {"fa" "∀"}
  {"pd" "∂"}
  {"te" "∃"}
  {"es" "∅"}
  {"De" "∆"}
  {"gr" "∇"}
  {"mo" "∈"}
  {"!m" "∉"}
  {"st" "∍"}
  {"pr" "∏"}
  {"su" "∑"}
  {"-+" "∓"}
  {"**" "∗"}
  {"sr" "√"}
  {"pt" "∝"}
  {"if" "∞"}
  {"an" "∠"}
  {"l&" "∧"}
  {"l|" "∨"}
  {"ca" "∩"}
  {"cu" "∪"}
  {"is" "∫"}
  {"tf" "∴"}
  {"-~" "≂"}
  {"~-" "≃"}
  {"!~-" "≄"}
  {"cg" "≅"}
  {"~!=" "≆"}
  {"!~=" "≇"}
  {"~~" "≈"}
  {"!~~" "≉"}
  {":=" "≔"}
  {"=:" "≕"}
  {"!=" "≠"}
  {"==" "≡"}
  {"<=" "≤"}
  {">=" "≥"}
  {"<!=" "≨"}
  {">!=" "≩"}
  {"!<" "≮"}
  {"!>" "≯"}
  {"<~" "≲"}
  {">~" "≳"}
  {"<>" "≶"}
  {"><" "≷"}
  {"sb" "⊂"}
  {"sp" "⊃"}
  {"!b" "⊄"}
  {"!p" "⊅"}
  {"ib" "⊆"}
  {"ip" "⊇"}
  {"+O" "⊕"}
  {"-O" "⊖"}
  {"Ox" "⊗"}
  {"O/" "⊘"}
  {"O|" "⌽"}
  {"O\\" "⍉"}
  {".O" "⊙"}
  {"Oo" "⊚"}
  {"O*" "⊛"}
  {"=O" "⊜"}
  {"tu" "⊢"}
  {"Tu" "⊨"}
  {"L&" "⋀"}
  {"L|" "⋁"}
  {"CA" "⋂"}
  {"CU" "⋃"}
  {"lz" "⋄"}
  {"=<" "⋜"}
  {"=>" "⋝"}
  {"<!~" "⋦"}
  {">!~" "⋧"}
  {"el" "⋯"}
  {"b" "␣"}
  {":(" "☹"}
  {":)" "☺"}
  {"wk" "♔"}
  {"wq" "♕"}
  {"wr" "♖"}
  {"wb" "♗"}
  {"wn" "♘"}
  {"wp" "♙"}
  {"bk" "♚"}
  {"bq" "♛"}
  {"br" "♜"}
  {"bb" "♝"}
  {"bn" "♞"}
  {"bp" "♟"}
  {"M4" "♩"}
  {"a" "♪"}
  {"d" "♭"}
  {"e" "♮"}
  {"f" "♯"}
  {"q" "⎕"}
  {"o" "∘"}
  {"x" "×"}
  {"to" "⍎"}
  {"[|" "⟦"}
  {"|]" "⟧"}
  {"sk" "☠"}
  {"+>" "⇸"}
  {"<+" "⇷"}
  {"bl" "∎"}
  {"==>" "⇒"}
  {"tup" "⊤"}
  {"tdn" "⊥"}
}
